
% (C) Copyright 1992
% Institute for New Generation Computer Technology, Japan
% ALL RIGHTS RESERVED

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% July  30, 1992     SANO,H. %
% August 25, 1992    SANO,H. %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Parameters

translator('~/sax/strn.pl').

grammar(v62,'~/FSE/SAX-Grm/grmV62/').

file_name(body,'LUG_S_L').
file_name(extra,'EXTRA_L').

extension(body,'.dcg.sax').
extension(extra,'.dcg').

% Usage Summary

% Loading the SAX-translator.
% To load SAX-translator, use loader/1.

sax_translator :-
	translator(Translator),
	consult(Translator),
	nl,
	write('>> To invoke the SAX translator: issue "tran" <<'),
	nl.

% Invoking the SAX translator.
% :- tran.
% The example above shows how to start a translation, using the SAX-translator.


% Invoking a parser.
% After you translate your grammar rules and then enter the sftb/2 predicate.
%
% sftb(Version,Level).
% Version : v62
% Level   : level1 to level12

sftb(Version,Level) :-
	grammar(Version,Path),
	name(Path,PathL),
      (	name(Level,[_,_,_,_,_,N]),
		Num = [N]
      ;	name(Level,[_,_,_,_,_,N1,N2]),
		Num = [N1,N2]	),
	grammar_file(PathL,Num,GFile),
	consult(GFile),
	extra_file(PathL,Num,PFile),
	consult(PFile),
	utilities.
% Error
sftb(Version,Level) :-
	write('Irregal Version or Level was specified : '),
	write(Version), write(' or '), write(Level), nl,
	fail.

grammar_file(Path,Level,File) :-
	file_name(body,Body),
	name(Body,BodyL),
	append(Path,BodyL,F),
	append(F,Level,Fi),
	extension(body,Ext),
	name(Ext,ExtL),
	append(Fi,ExtL,Fil),
	name(File,Fil).

extra_file(Path,Level,File) :-
	file_name(extra,Body),
	name(Body,BodyL),
	append(Path,BodyL,F),
	append(F,Level,Fi),
	extension(extra,Ext),
	name(Ext,ExtL),
	append(Fi,ExtL,Fil),
	name(File,Fil).

utilities :-
        ['~/FSE/SAX-Grm/lib/option',
         '~/sax/process',
         '~/sax/visips',
         '~/sax/time',
         '~/sax/util',
         '~/sax/vtree',
         '~/sax/htree',
         '~/sax/sax',
         '~/sax/fin',
         '~/sax/input'].

% Miscellaneous predicates

append([],L,L) :- !.
append([X|T],Y,[X|Z]) :-
	append(T,Y,Z).

% End of File
